var aid = null;
var myStepDetector = new SimpleStepDetector();
function watchAcc() {
	if ( aid ) {
		return;
	}
	
//	outSet( "监听设备加速度变化" );
	aid = plus.accelerometer.watchAcceleration( function ( a ) {
		myStepDetector.updateAccel(a.xAxis,a.yAxis,a.zAxis);
		//outSet( "监听设备加速度变化\n" + "X轴：" + a.xAxis + "\nY轴：" + a.yAxis + "\nZ轴：" + a.zAxis )
	}, function ( e ) {
		outLine( "监听失败:" + e.message );
	} , {frequency:20} ); // 设置更新间隔时间ms
}
function watchStop() {
	if ( aid ) {
		outSet( "停止监听设备加速度变化" );
		plus.accelerometer.clearWatch( aid );
		aid = null;
	} else {
		outSet( "没有监听设备加速度变化" );
	}
}

function SimpleStepDetector() {
	this.ACCEL_RING_SIZE = 50;
	this.VEL_RING_SIZE = 10;
	this.STEP_THRESHOLD = 4;
	this.STEP_DELAY_NS = 250; //250000000;

	this.accelRingCounter = 0;
	this.accelRingX = new Array(this.ACCEL_RING_SIZE);
	this.accelRingY = new Array(this.ACCEL_RING_SIZE);
	this.accelRingZ = new Array(this.ACCEL_RING_SIZE);
	this.velRingCounter = 0;
	this.velRing = new Array(this.VEL_RING_SIZE);
	this.lastStepTimeNs = 0;
	this.oldVelocityEstimate = 0;
	this.SensorFusionMath = new MySensorFusionMath();
	this.numSteps = 0;
	this.lastNumSteps = 0;
	this.lastStepTime = new Date().getTime();

	this.step = function(timeNs) {
		this.numSteps++;
		//outSet("步数：" + this.numSteps);
		_myNumSteps_.innerText = this.numSteps;
	}

	this.test = function() {
			//			var arr = new Array(3, 1, 6);
			//			var a = this.SensorFusionMath.sum(arr);

		}
		/**
		 * Accepts updates from the accelerometer.
		 */
	this.updateAccel = function(x, y, z) {
		var timeNs = new Date().getTime(); //getSeconds() / 1000000000; //纳秒是一秒的10亿分之一
		var currentAccel = new Array(3);
		currentAccel[0] = x;
		currentAccel[1] = y;
		currentAccel[2] = z;

		// First step is to update our guess of where the global z vector is.
		this.accelRingCounter++;
		this.accelRingX[this.accelRingCounter % this.ACCEL_RING_SIZE] = currentAccel[0];
		this.accelRingY[this.accelRingCounter % this.ACCEL_RING_SIZE] = currentAccel[1];
		this.accelRingZ[this.accelRingCounter % this.ACCEL_RING_SIZE] = currentAccel[2];

		var worldZ = new Array(3);
		worldZ[0] = this.SensorFusionMath.sum(this.accelRingX) / Math.min(this.accelRingCounter, this.ACCEL_RING_SIZE);
		worldZ[1] = this.SensorFusionMath.sum(this.accelRingY) / Math.min(this.accelRingCounter, this.ACCEL_RING_SIZE);
		worldZ[2] = this.SensorFusionMath.sum(this.accelRingZ) / Math.min(this.accelRingCounter, this.ACCEL_RING_SIZE);

		var normalization_factor = this.SensorFusionMath.norm(worldZ);

		worldZ[0] = worldZ[0] / normalization_factor;
		worldZ[1] = worldZ[1] / normalization_factor;
		worldZ[2] = worldZ[2] / normalization_factor;

		// Next step is to figure out the component of the current acceleration
		// in the direction of world_z and subtract gravity's contribution
		var currentZ = this.SensorFusionMath.dot(worldZ, currentAccel) - normalization_factor;
		this.velRingCounter++;
		this.velRing[this.velRingCounter % this.VEL_RING_SIZE] = currentZ;

		var velocityEstimate = this.SensorFusionMath.sum(this.velRing);

		if (velocityEstimate > this.STEP_THRESHOLD && this.oldVelocityEstimate <= this.STEP_THRESHOLD && (timeNs - this.lastStepTimeNs > this.STEP_DELAY_NS)) {
			this.step(timeNs);
			this.lastStepTimeNs = timeNs;
		}
		this.oldVelocityEstimate = velocityEstimate;
	}

}

function MySensorFusionMath() {

	this.sum = function(arr1) {
		var retval = 0;
		for (i in arr1) {
			retval += arr1[i];

		}
		return retval;
	}

	this.cross = function(arrayA, arrayB) {
		var retArray = new Array(3);
		retArray[0] = arrayA[1] * arrayB[2] - arrayA[2] * arrayB[1];
		retArray[1] = arrayA[2] * arrayB[0] - arrayA[0] * arrayB[2];
		retArray[2] = arrayA[0] * arrayB[1] - arrayA[1] * arrayB[0];
		return retArray;
	}

	this.norm = function(arr) {
		var retval = 0;
		for (i in arr) {
			retval += arr[i] * arr[i];
		}
		return Number(Math.sqrt(retval));
	}

	// Note: only works with 3D vectors.
	this.dot = function(a, b) {
		var retval = (a[0] * b[0]) + (a[1] * b[1]) + (a[2] * b[2]);
		return retval;
	}

	this.normalize = function(a) {
		var retval = new Array(a.length);
		var n = this.norm(a);
		for (i in a) {
			retval[i] = a[i] / n;
		}
		return retval;
	}

}

